/*
* This computer program is the confidential information and proprietary
* trade secret of Cisco Systems, Inc.  Possessions and use of this
* program must conform strictly to the license agreement between the user
* and Cisco Systems, Inc., and receipt or possession does not convey
* any rights to divulge, reproduce, or allow others to use this program
* without specific written authorization of Cisco Systems, Inc.
*
*      Copyright (c) 2015 Cisco Systems, Inc.
*      All rights reserved.
*/

define([
	"dojo/_base/declare",
	"xwt/widget/LoginPage",
	"dojo/dom-construct",
	"dojo/_base/array",
	"dojo/_base/lang",
	"dojo/i18n",
	"wcs/widget/InstalledUpdatesPopover",
	"xwt/widget/_i18nMixin",
	"dojo/query",
	"dojo/has",
	"dijit/form/CheckBox",
	"dojo/dom-class",
	"dojo/_base/connect",
	"dojo/text!./templates/LoginPageOSCP.html"
], function(declare, login, domConstruct, array, lang, i18n, InstalledUpdatesPopover, _i18nMixin,dQuery,has,CheckBox,domClass,conHub, LogintemplateOSCP){
	
	var NCS = lang.getObject("NCS");
	var localStorage = lang.getObject("localStorage");
	var location = lang.getObject("location");
	
	return declare("wcs.widget.NCSLoginPage", [login, xwt.widget._i18nMixin], {
		isCLuster: false,
		nbifailed: "",
		vdfailed: "",	
		lockfailed: "",
		loginattemptslimitreached: "",
		authfailserver:"",
		accessChallenge: "",
		sessionlimit:"",
		ocspLoginFailure:"",
		installedUpdatesTitle: "",
        invalidCertificate:"",
        ocspAuthFailure:"",
        ocspClearChache:"",
        OCSPCertificateStatus:"",
		i18nPackageName: "xmp",
		i18nBundleName: "xmp",
		//wcsEnableAutocomplete: Boolean
		// if it is true enable autocomplete otherwise if false disables autocomplete
		clientAuthStatus: "",
		continueBtnLabel: "continue_button",
		wcsEnableAutocomplete: true,
		allowCopyPastePassword: true,
		displayMessageByID: function(/*String*/id) {
			if(id && id==="nbi_failed"){
				this.showAlertBox("warning", this.nbifailed);
			}
			else if(id && id==="vd_failed"){
				this.showAlertBox("warning", this.vdfailed);
			}
			else if(id && id==="lock_failed"){
				this.showAlertBox("warning", this.lockfailed);
			}
			else if(id && id==="login_attempts_limit_reached"){
				this.showAlertBox("warning", this.loginattemptslimitreached);
			}
			else if(id && id==="auth_failed_server"){
			   this.showAlertBox("warning", this.authfailserver);
			}
			else if(id && id==="auth_access_challenge"){
			   this.showAlertBox("warning", this.accessChallenge);
			}
			else if(id && id=="session_limit"){
			   this.showAlertBox("warning", this.sessionlimit);
			}else if(id && id=="ocspLogin_Failure"){
			   this.showAlertBox("warning", this.ocspLoginFailure);
			}
			else if(id && id=="invalid_cert"){
			   this.showAlertBox("warning", this.invalidCertificate);
			}
			else if(id && id=="ocspAuth_Failure"){
			   this.showAlertBox("warning", this.ocspAuthFailure);
			}
			else if(id && id=="ocsp_clear_chache"){
				   this.showAlertBox("warning", this.ocspClearChache);
			}
			else{
					this.inherited(arguments);
			}
	},

	postMixInProperties: function(){
		this.informationText = this.informationText.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/"/g, '&quot;').replace(/'/g, '&apos;');
		try{
			if(NCS.CONSTANTS.isFIPS_MODE && this.informationText.length == 0){
				this.informationText = "  ";
			}
		}catch(e){
			}
		this.inherited(arguments);
		this.continueBtnLabel = this.getI18nLabel(this.continueBtnLabel,"Continue");
		
		if(this.clientAuthStatus == "1"){
			this.templateString = LogintemplateOSCP;
			this.validInfoMessageIDs.push("ocsp_logged_out");
			this.validMessageIDs.push("ocsp_logged_out");
		}
	 },
	
	postCreate: function(){
		this.inherited(arguments);
		if(localStorage){
			// If localStorage is not supported by the browser, we cannot handle multiple language support.
			this.addLanguageNode();
		}
		this.addInstalledUpdateWidget();
		
		var _isvalidCert = this.OCSPCertificateStatus.indexOf("GOOD"), _clientAuthStatus = (this.clientAuthStatus == "1")? true : false; 
		
		if( (_clientAuthStatus && !this.invalidCertificate) || this.midvalue === "ocsp_logged_out" || this.midvalue === "ocspAuth_Failure" || this.midvalue === "ocsp_clear_chache"){
			dijit.byId("loginPage_LoginButton").set('disabled','disabled');
		}else if(_clientAuthStatus && _isvalidCert !== -1){
			// CSCvx17137 Current design requires username & password values during the authentication flow.
			// Therefore a dummy value is set here. Firefox shows save password alert
			this.usernameField.set('value', 'certificate_user');
			this.passwordField.set('value','password');
			dijit.byId("loginPage_LoginButton").set('disabled','');
		}
		
		NCS.CONSTANTS.isFIPS_MODE && conHub.connect(this.obAcknow_Chk, "onkeyup", lang.hitch(this, function (ev){ 
			if(ev.keyCode === 13 && !this.loginButton.disabled){
				domClass.remove(this.spinnerNode, "xwtLoginHidden");
				this.onClickSubmit();
			}
		}));
	},
	
	startup: function(){
		this.inherited(arguments);
		if(!this.wcsEnableAutocomplete){
			dojo.attr(this.usernameAP.textbox, "autocomplete", "off");
		}
		 this.sessionlimit = this.getI18nLabel("sessionLimit","You have exceeded the number of active sessions allowed for this user. Log out of one active session, or wait for up to 30 minutes and log in again.");
      	this.nbifailed= this.getI18nLabel("nbifailed","North Bound API users are not allowed to login via the web GUI.");
		this.vdfailed= this.getI18nLabel("vdfailed","No authorization information found for Remote Authenticated User. Please check the correctness of the  associated task(s) and Virtual Domain(s) in the remote server");
		this.lockfailed= this.getI18nLabel("lockfailed","This account is locked. Please contact the Network Administrator for assistance or retry later.");
		this.loginattemptslimitreached = this.getI18nLabel("loginattemptslimitreached", "Too many unsuccessful login attempts. Please contact the Network Administrator for assistance or retry later.");
		this.authfailserver= this.getI18nLabel("authfailserver","Invalid Username or Password. Please try again. or Please contact the Network Admin for assistance.");

		this._i18nMessages["session_limit"]= this.sessionlimit;
		this._i18nMessages["nbi_failed"]= this.nbifailed;
		this._i18nMessages["vd_failed"]= this.vdfailed;
		this._i18nMessages["lock_failed"]= this.lockfailed;
		this._i18nMessages["login_attempts_limit_reached"]= this.loginattemptslimitreached;
		this._i18nMessages["auth_failed_server"]= this.authfailserver;
		this._i18nMessages["auth_access_challenge"]= this.accessChallenge;
		this._i18nMessages["ocspLogin_Failure"]= this.ocspLoginFailure;
		this._i18nMessages["ocspAuth_Failure"]= this.ocspAuthFailure;
        this._i18nMessages["invalid_cert"]= this.invalidCertificate;
        this._i18nMessages["ocsp_clear_chache"]= this.ocspClearChache;
		if(NCS.CONSTANTS.isFIPS_MODE){
			this.obAcknow_Label = domConstruct.create("div",{"innerHTML":"Acknowledge","style":"float:left;color:#00B2EC;font-size:1.1rem;margin-right:0.5rem;padding-top:1px;"});
			this.obAcknow_Chk =  new dijit.form.CheckBox({
											name: "checkBox",
											value: "agreed",
											style:"float:left;",
											checked: false,
											onChange: lang.hitch(this, "_onChange_Acknow", this)								
											
										});
			//var obChk=new dijit.form.CheckBox({"label":"jose"});
			domConstruct.place(this.obAcknow_Label,this.notesNode,"first");
			domConstruct.place(this.obAcknow_Chk.domNode,this.notesNode,"first");
			conHub.connect(dQuery("body")[0], "onclick", lang.hitch(this, "_onBodyClick"));

			dojo.style(this.notesNodeContainer , {"padding-top":"1px"});

			if(lang.trim(this.messageID)===""){
				this.clearMessages();
				this.displayMessage(this._i18nMessages["acknowledge_label"] || "Please acknowledge the disclaimer to login","info");
			}
		}
	},
_onChange_Acknow:function(_self,isChecked){
		
		if(isChecked){
			//_self.obAcknow_Label.innerHTML = "Acknowledge  ";
			if(_self._isEmpty()){
				_self.loginButton.set("disabled",true);
			}else{
				_self.loginButton.set("disabled",false);
			}
			

		}else{
			//_self.obAcknow_Label.innerHTML = "Un Acknowledge  ";
			_self.loginButton.set("disabled",true);
		}
	},
	_onBodyClick:function(evt){
		var node = evt.target,
			  db = dQuery("body")[0], isBox=false;
			 
		while(node && node !== db && !isBox){
			if(dojo.hasClass(node,"dijitInputField")){
				isBox=true;
			}
			node = node.parentNode;
		}
		if(!isBox){
			dijit.hideTooltip(this.notesNode);
		}
	},
	_isEmpty:function(){
		var disabled = false;
		if(this.requireUsername){
			v = lang.trim(this.usernameField.get("value"));
			if(!v && v===""){
				disabled = true;
			}
		}
		if(this.requirePassword){
			v = lang.trim(this.passwordField.get("value"));
			if(!v && v===""){
				if(has("webkit")){
					// This block works around the issue where chrome will autofill but
					// make the value unreadable.  I can look for a class they add and if it is there
					// they autofilled it and we can assume it has a value, and enable the button.
					// We also have to clear the placeholder.
					var autoFilled = false;
					var pwFields = dQuery("input:-webkit-autofill", this.passwordField.domNode);
					if(pwFields && pwFields.length === 1){
						autoFilled = true;						
					}
					disabled = disabled || !autoFilled;
				}else{
					disabled = true;
				}
			}
		}
		return disabled;
	},


	addLanguageNode: function(){
		if (this.isCLuster) {
			return;
		}
		var supportedLanguage = [
			{label: "English", locale: "en"},
			{label: "日本語", locale: "ja"},
			{label: "한국어", locale: "ko"}
		];
		var i18n = dojo.i18n["getLocalization"]("xmp","xmp");
		var node = domConstruct.create("div", {"class":"languageNode"}, this.loginFieldsNode, "after");
		var labelNode = domConstruct.create("div", {"class": "dijitInline langLabel", innerHTML: i18n.languages}, node);
		array.forEach(supportedLanguage, function(langObj, idx){
			if(idx !== 0){
				domConstruct.create("div", {"class": "dijitInline itemSeperator", innerHTML: " | "}, node);
			}
			var nodeClass = "dijitInline xwtLinkCSS";
			if(NCS.CONSTANTS.locale === langObj.locale){
				nodeClass += " isSelected";
			}
			domConstruct.create("div", {"class": nodeClass, innerHTML: langObj.label, onclick: lang.hitch(this, "onLocaleClick", langObj)}, node);
		}, this);
	},
	
	onLocaleClick: function(langObj){
		if(langObj.locale === NCS.CONSTANTS.locale){
			return;
		}
		localStorage.setItem("userSelectedLocale", langObj.locale);
		location.reload();
	},
	
	addInstalledUpdateWidget: function(){
		if(this.installedUpdatesWidget || this.isCLuster){
			return;
		}
		
                this.installedUpdatesTitle = this.getI18nLabel("installedUpdates","Installed Updates");
		this.installedUpdatesWidget = new InstalledUpdatesPopover({installedUpdatesTitle: this.installedUpdatesTitle}, domConstruct.create("div", {}, this.customElements));
	},
	
	/***
	The supported browser call is copied from XWT to PI .
	As it specific to PI - which does not support FF - but supports ESR and there is no API to recoginze as ESR.
	Sanjay Shrivastav  from WAP team owns this

	**/

	isBrowserSupported: function(){
			if(!this.checkBrowser){ return;}
			xwt.supportedBrowser = this.supportedBrowserList;

			if(!this.isSupportedBrowser()){
				dojo.style(this.messageBoxAP, {
					"display": "block"
				});
				dojo.style(this.browserNotification, {
					"display": "block"
				});
			}
	 },

	isSupportedBrowser: function (){

		var browserList = dojo.config.supportedBrowser || xwt.supportedBrowser;
		for(var b in browserList){
			var arr = browserList[b];
			if(b=='ESR'){
			   b='FF';
			}
			if(dojo.isArray(arr)){
				for(var arrVal in arr){
					var browserVersion = arr[arrVal].toString();
					// This condition is to check if user mentioned supported versions like '3+' instead of 3,4,5,6,...
					if(browserVersion.indexOf("+") != -1){
						var _browserVersion = browserVersion.substring(0,browserVersion.indexOf("+"));
						if(Math.floor(dojo['is' + b]) >= parseInt(_browserVersion)){
							return true;
						}
					}
					
				}
				if(dojo.indexOf(arr, Math.floor(dojo['is' + b])) != -1){
					return true;
				}
			}else{
				if(dojo['is' + b]){
					return true;
				}
			}
			
		}

		return false;
	},
	_checkState: function(){
		this.inherited(arguments);
		if(NCS.CONSTANTS.isFIPS_MODE){
			var disabled = this.loginButton.get("disabled");
			if(!disabled) {
				if(this.obAcknow_Chk && this.obAcknow_Chk.get("value") == "agreed"){
					this.loginButton.set("disabled", disabled);
				}else{
					this.loginButton.set("disabled", true);
				}
			}

			if(!this._isEmpty()){
				if(this.messageBoxNode){
					 this.messageBoxNode.innerHTML = "";
				}
				this.displayMessage(this._i18nMessages["acknowledge_label"] || "Please acknowledge the disclaimer to login","info");
				if(this.obAcknow_Chk && this.obAcknow_Chk.get("value") != "agreed"){
					dijit.showTooltip(this._i18nMessages["acknowledge_tooltip"]||"Please acknowledge to proceed",this.notesNode,['above']);
				}
			}
		}
		
	}

	});
});
